package prodcons;

import java.util.Observable;

public class Consumer extends Observable implements Runnable {

    public static enum State {

        READING, CONSUMING;
        private int value;

        public void setValue(int value) {
            this.value = value;
        }

        public int getValue() {
            return value;
        }
    }
    private State state;
    private Buffer sharedLocation;

    public Consumer(Buffer shared) {
        sharedLocation = shared;
    }

    public void run() {
        while (true) {
            updateState(State.READING, 0);
            int doba = sharedLocation.get();
            updateState(State.CONSUMING, doba);
            try {
                Thread.sleep(doba);
            } catch (InterruptedException e) {
            }
        }
    }

    private void updateState(State state, int value) {
        state.setValue(value);
        this.state = state;
        setChanged();
        notifyObservers();
    }

    public State getState() {
        return state;
    }
}
